Index: reactapp/src/Pages/Professor.js
===================================================================
--- reactapp/src/Pages/Professor.js	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ reactapp/src/Pages/Professor.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -32,4 +32,6 @@
   const [professor, setProfessor] = useState(null);
   const [loadedProfessor, setLoadedProfessor] = useState(false);
+  const [relatedOpinions, setRelatedOpinions] = useState(null);
+  const [loadedRelatedOpinions, setLoadedRelatedOpinions] = useState(false);
 
   const [postModalDisplay, setPostModalDisplay] = useState("none");
@@ -40,21 +42,22 @@
 
   useEffect(() => {
-    const url = `http://192.168.0.29:8080/public/professor/${params.professorId}`;
+     Promise.all([fetch(`http://192.168.1.254:8080/public/professor/${params.professorId}`),
+     fetch(`http://192.168.1.254:8080/public/professor/${params.professorId}/relatedOpinions`)])
+        .then(([resProfessor, resRelatedOpinions]) => Promise.all([resProfessor.json(), resRelatedOpinions.json()]))
+        .then(([dataProfessor, dataRelatedOpinions]) => {
+          let cyclicGraph1 = dataProfessor;
+          let jsogStructure1 = JSOG.encode(cyclicGraph1);
+          cyclicGraph1 = JSOG.decode(jsogStructure1);
+          setProfessor(cyclicGraph1);
+          setLoadedProfessor(true);
 
-    const fetchProfessor = async () => {
-      try {
-        const response = await fetch(url);
-        var cyclicGraph = await response.json();
-        var jsogStructure = JSOG.encode(cyclicGraph);
-        cyclicGraph = JSOG.decode(jsogStructure);
-        setProfessor(cyclicGraph);
-        setLoadedProfessor(true);
-      } catch (error) {
-        setFetchError(true);
-      }
-    };
+          let cyclicGraph2 = dataRelatedOpinions;
+          let jsogStructure2 = JSOG.encode(cyclicGraph2);
+          cyclicGraph2 = JSOG.decode(jsogStructure2);
+          setRelatedOpinions(cyclicGraph2);
+          setLoadedRelatedOpinions(true);
+        })
 
-    fetchProfessor();
-  }, [params.professorId]);
+  }, []);
 
   const handleAddOpinionButtonClick = () => {
@@ -77,5 +80,5 @@
     if (!postContent.length < 1) {
       const response = await axios(
-        `http://192.168.0.29:8080/secure/professor/${params.professorId}/addOpinion`,
+        `http://192.168.1.254:8080/secure/professor/${params.professorId}/addOpinion`,
         {
           method: "post",
@@ -129,6 +132,6 @@
             }}
           >
-            {professor.relatedOpinions.length}{" "}
-            {professor.relatedOpinions.length !== 1 ? "мислења" : "мислење"}
+            {relatedOpinions.length}{" "}
+            {relatedOpinions.length !== 1 ? "мислења" : "мислење"}
           </h3>
           {auth && (
@@ -172,5 +175,5 @@
 
         <div className="opinionTree">
-          <OpinionTree professor={professor} />
+          <OpinionTree professor={professor} relatedOpinions={relatedOpinions}/>
         </div>
         <Outlet />
Index: reactapp/src/Pages/PublicUserProfile.js
===================================================================
--- reactapp/src/Pages/PublicUserProfile.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
+++ reactapp/src/Pages/PublicUserProfile.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -0,0 +1,57 @@
+import React, {useEffect, useState} from 'react';
+import {UserDetailsCard, UserDetailsCardContent} from "../Components/Styled/UserDetails.style";
+import {useParams} from "react-router-dom";
+import JSOG from "jsog";
+import LoadingSpinner from "../Components/Styled/LoadingSpinner.style";
+
+const PublicUserProfile = () => {
+    let params = useParams();
+
+    const [publicProfile, setPublicProfile] = useState(null);
+    const [loadedPublicProfile, setLoadedPublicProfile] = useState(false);
+
+    useEffect(() => {
+            const fetchPublicProfile = async () => {
+                const resp = await fetch(`http://192.168.1.254:8080/public/user/${params.userId}`)
+                let cyclicGraph = await resp.json();
+                let jsogStructure = JSOG.encode(cyclicGraph);
+                cyclicGraph = JSOG.decode(jsogStructure);
+                setPublicProfile(cyclicGraph);
+                setLoadedPublicProfile(true);
+            }
+            fetchPublicProfile();
+        },
+        []
+    )
+
+    return <>
+        {loadedPublicProfile ?
+            (<>
+                <h3>Кориснички податоци за корисник #{publicProfile.id}:</h3>
+            <UserDetailsCard>
+                {publicProfile.fullName && (
+                    <UserDetailsCardContent>
+                        <b>Име:</b> {publicProfile.fullName}{" "}
+                    </UserDetailsCardContent>
+                )}
+                <UserDetailsCardContent>
+                    <b>Корисничко име:</b> {publicProfile.username}{" "}
+                </UserDetailsCardContent>
+                <UserDetailsCardContent>
+                    <b>E-mail:</b> {publicProfile.email}
+                </UserDetailsCardContent>
+                <UserDetailsCardContent>
+                    <b>Карма:</b>{" "}
+                    <span style={{color: publicProfile.karma < 0 ? "indianred" : "green"}}>
+                {publicProfile.karma}
+              </span>
+                </UserDetailsCardContent>
+            </UserDetailsCard>
+            </>)
+            :
+            <LoadingSpinner/>
+        }
+    </>
+};
+
+export default PublicUserProfile;
Index: reactapp/src/Pages/SearchResults.js
===================================================================
--- reactapp/src/Pages/SearchResults.js	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ reactapp/src/Pages/SearchResults.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -14,12 +14,12 @@
     <SearchResultsWrapper>
       <h3 style={{ marginBottom: "30px" }}>Резултати од пребарувањето:</h3>
-      {location.state.map((professor) => (
-        <SearchResult key={professor.professorId} margin="10px">
-          <SearchResultLink href={"/professor/" + professor.professorId}>
+      {location.state.map((match) => (
+        <SearchResult key={match.professorId !== undefined ? match.professorId : match.subjectId} margin="10px">
+          <SearchResultLink href={`/${match.professorId !== undefined ? 'professor': 'subject'}/` + `${match.professorId !== undefined ? match.professorId : match.subjectId}`}>
             <SearchResultText weight="bold" size="medium">
-              {professor.professorName}
+              {match.professorId !== undefined ? match.professorName : match.subjectName}
             </SearchResultText>
             <SearchResultText weight="normal" size="er">
-              {professor.faculty.facultyName}
+              {match.professorId !== undefined ? match.faculty.facultyName : match.studyProgramme.faculty.facultyName}
             </SearchResultText>
           </SearchResultLink>
Index: reactapp/src/Pages/Subject.js
===================================================================
--- reactapp/src/Pages/Subject.js	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ reactapp/src/Pages/Subject.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -33,9 +33,12 @@
   let params = useParams();
   let navigate = useNavigate();
-
   const { auth, setAuth } = useContext(AuthApi);
+
   const [subject, setSubject] = useState(null);
-  const [loaded, setLoaded] = useState(false);
+  const [loadedSubject, setLoadedSubject] = useState(false);
+  const [threads, setThreads] = useState(null);
+  const [loadedThreads, setLoadedThreads] = useState(false);
   const [fetchError, setFetchError] = useState(false);
+
   var totalTopics = 0;
   var topics = [];
@@ -47,21 +50,22 @@
 
   useEffect(() => {
-    const url = `http://192.168.0.29:8080/public/subject/${params.subjectId}`;
-
-    const fetchData = async () => {
-      try {
-        const response = await fetch(url);
-        let cyclicGraph = await response.json();
-        let jsogStructure = JSOG.encode(cyclicGraph);
-        cyclicGraph = JSOG.decode(jsogStructure);
-        setSubject(cyclicGraph);
-        setLoaded(true);
-      } catch (error) {
-        setFetchError(true);
-      }
-    };
-
-    fetchData();
-  }, [params.subjectId]);
+    Promise.all([fetch(`http://192.168.1.254:8080/public/subject/${params.subjectId}`),
+                        fetch(`http://192.168.1.254:8080/public/subject/${params.subjectId}/threads`)])
+        .then(([resSubject, resThreads]) => Promise.all([resSubject.json(), resThreads.json()]))
+        .then(([dataSubject, dataThreads]) => {
+          let cyclicGraph1 = dataSubject;
+          let jsogStructure1 = JSOG.encode(cyclicGraph1);
+          cyclicGraph1 = JSOG.decode(jsogStructure1);
+          setSubject(cyclicGraph1);
+          setLoadedSubject(true);
+
+          let cyclicGraph2 = dataThreads;
+          let jsogStructure2 = JSOG.encode(cyclicGraph2);
+          cyclicGraph2 = JSOG.decode(jsogStructure2);
+          setThreads(cyclicGraph2);
+          setLoadedThreads(true);
+        })
+
+  }, []);
 
   const handleAddTopicButtonClick = () => {
@@ -84,5 +88,5 @@
     if (!topicTitle.length < 1 && !topicContent.length < 1) {
       const response = await axios(
-        `http://192.168.0.29:8080/secure/subject/${params.subjectId}/addThread`,
+        `http://192.168.1.254:8080/secure/subject/${params.subjectId}/addThread`,
         {
           method: "post",
@@ -109,5 +113,5 @@
   };
 
-  return loaded ? (
+  return loadedSubject ? (
     <>
       <CurrentPageNav>
@@ -151,5 +155,5 @@
           }}
         >
-          {subject.threads.map((thread) => {
+          {threads.map((thread) => {
             if (thread.parent === null) {
               totalTopics++;
@@ -210,5 +214,5 @@
             <EntityUl key={topic.postId}>
               <EntityLi bgcolor="cornsilk">
-                <a href={"/topic/" + topic.postId}>{topic.title}</a>
+                <a href={"/topic/" + topic.postId}>{topic.title.length >= 99 ? topic.title.slice(0,98) + "..." : topic.title}</a>
                 <EntityParam right="30px">
                   <span style={{ fontWeight: "normal" }}>
Index: reactapp/src/Pages/Topic.js
===================================================================
--- reactapp/src/Pages/Topic.js	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ reactapp/src/Pages/Topic.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -43,12 +43,18 @@
   const [postModalDisplay, setPostModalDisplay] = useState("none");
   const [postContent, setPostContent] = useState("");
+
   const [replyModalDisplay, setReplyModalDisplay] = useState("none");
   const [replyContent, setReplyContent] = useState("");
-  const [postForModal, setPostForModal] = useState(null);
+  const [postForReplyModal, setPostForReplyModal] = useState(null);
+
+  const [reportModalDisplay, setReportModalDisplay] = useState("none");
+  const [reportContent, setReportContent] = useState("");
+  const [postForReportModal, setPostForReportModal] = useState(null);
+
   const [errorMessage, setErrorMessage] = useState("");
 
   useEffect(() => {
-    const url1 = `http://192.168.0.29:8080/public/thread/${params.topicId}`;
-    const url2 = `http://192.168.0.29:8080/secure/currentUser`;
+    const url1 = `http://192.168.1.254:8080/public/thread/${params.topicId}`;
+    const url2 = `http://192.168.1.254:8080/secure/currentUser`;
 
     const fetchTopic = async () => {
@@ -79,10 +85,20 @@
 
     fetchTopic().then(fetchUser);
-  }, []);
+  }, [loadedThread]);
 
   const handleReply = (post) => {
     if (auth) {
       setReplyModalDisplay("block");
-      setPostForModal(post);
+      setPostForReplyModal(post);
+      document.body.style.overflowY = "hidden";
+    } else {
+      navigate("/login");
+    }
+  };
+
+  const handleReport = (post) => {
+    if (auth) {
+      setReportModalDisplay("block");
+      setPostForReportModal(post);
       document.body.style.overflowY = "hidden";
     } else {
@@ -95,4 +111,9 @@
   };
 
+  const handleReportContentChange = (e) => {
+    e.preventDefault();
+    setReportContent(e.target.value);
+  };
+
   const handleReplySubmit = async (e, postId) => {
     e.preventDefault();
@@ -100,5 +121,5 @@
     if (!replyContent.length < 1) {
       const response = await axios(
-        `http://192.168.0.29:8080/secure/subject/${thread.targetSubject.subjectId}/replyToThread/${postId}`,
+        `http://192.168.1.254:8080/secure/subject/${thread.targetSubject.subjectId}/replyToThread/${postId}`,
         {
           method: "post",
@@ -116,4 +137,25 @@
   };
 
+  const handleReportSubmit = async (e, postId) => {
+    e.preventDefault();
+
+    if (!reportContent.length < 1) {
+      const response = await axios(
+          `http://192.168.1.254:8080/secure/reportThread/${postId}`,
+          {
+            method: "post",
+            data: {
+              description: reportContent,
+            },
+            withCredentials: true,
+          }
+      );
+      setErrorMessage("");
+      window.location.reload();
+    } else {
+      setErrorMessage("Полето за содржина не смее да биде празно");
+    }
+  };
+
   const handleAddOpinionButtonClick = () => {
     if (auth) {
@@ -129,5 +171,5 @@
     if (!postContent.length < 1) {
       const response = await axios(
-        `http://192.168.0.29:8080/secure/subject/${thread.targetSubject.subjectId}/replyToThread/${params.topicId}`,
+        `http://192.168.1.254:8080/secure/subject/${thread.targetSubject.subjectId}/replyToThread/${params.topicId}`,
         {
           method: "post",
@@ -147,4 +189,5 @@
     setPostModalDisplay("none");
     setReplyModalDisplay("none");
+    setReportModalDisplay("none");
     document.body.style.overflowY = "auto";
   };
@@ -161,5 +204,5 @@
       ) {
         const response = await axios(
-          `http://192.168.0.29:8080/secure/upvoteThread/${post.postId}`,
+          `http://192.168.1.254:8080/secure/upvoteThread/${post.postId}`,
           {
             method: "get",
@@ -184,5 +227,5 @@
       ) {
         const response = await axios(
-          `http://192.168.0.29:8080/secure/downvoteThread/${post.postId}`,
+          `http://192.168.1.254:8080/secure/downvoteThread/${post.postId}`,
           {
             method: "get",
@@ -280,4 +323,11 @@
                 color="darkgrey"
                 onClick={() => handleReply(child)}
+              />
+
+              <StyledFontAwesomeIcon
+                  icon={solid("flag")}
+                  right={130 + "px"}
+                  color="darkgrey"
+                  onClick={() => handleReport(child)}
               />
             </div>
@@ -393,4 +443,10 @@
           >
             <StyledFontAwesomeIcon
+                icon={solid("flag")}
+                right={90 + "px"}
+                color="darkgrey"
+                onClick={() => handleReport(thread)}
+            />
+            <StyledFontAwesomeIcon
               icon={solid("thumbs-up")}
               right={50 + "px"}
@@ -517,4 +573,11 @@
                   onClick={() => handleReply(directChild)}
                 />
+
+                <StyledFontAwesomeIcon
+                    icon={solid("flag")}
+                    right={130 + "px"}
+                    color="darkgrey"
+                    onClick={() => handleReport(directChild)}
+                />
               </div>
             </OpinionCardContent>
@@ -525,5 +588,5 @@
         );
       })}
-      {postForModal && (
+      {postForReplyModal && (
         <Modal display={replyModalDisplay}>
           <ModalContent>
@@ -531,8 +594,8 @@
               <ModalClose onClick={handleModalCloseClick}>&times;</ModalClose>
               <h3 style={{ marginTop: "5px" }}>
-                Реплика на {postForModal.author.username}
+                Реплика на {postForReplyModal.author.username}
               </h3>
             </ModalHeader>
-            <form onSubmit={(e) => handleReplySubmit(e, postForModal.postId)}>
+            <form onSubmit={(e) => handleReplySubmit(e, postForReplyModal.postId)}>
               <ModalBody>
                 <label htmlFor="content">
@@ -557,4 +620,36 @@
         </Modal>
       )}
+      {postForReportModal && (
+          <Modal display={reportModalDisplay}>
+            <ModalContent>
+              <ModalHeader>
+                <ModalClose onClick={handleModalCloseClick}>&times;</ModalClose>
+                <h3 style={{ marginTop: "5px" }}>
+                  Пријава за мислење #{postForReportModal.postId}
+                </h3>
+              </ModalHeader>
+              <form onSubmit={(e) => handleReportSubmit(e, postForReportModal.postId)}>
+                <ModalBody>
+                  <label htmlFor="content">
+                    <b>Наведете причина</b>:
+                    <ModalTextarea
+                        id="content"
+                        rows="8"
+                        cols="100"
+                        value={reportContent}
+                        onChange={handleReportContentChange}
+                    />
+                  </label>
+                </ModalBody>
+                <p
+                    style={{ color: "red", marginLeft: "15px", marginTop: "10px" }}
+                >
+                  {errorMessage}
+                </p>
+                <ModalFooter type="submit">ПРИЈАВИ</ModalFooter>
+              </form>
+            </ModalContent>
+          </Modal>
+      )}
     </>
   ) : !fetchError && !loadedThread ? (
Index: reactapp/src/Pages/University.js
===================================================================
--- reactapp/src/Pages/University.js	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ reactapp/src/Pages/University.js	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -18,27 +18,34 @@
 const University = () => {
   let params = useParams();
-  const [loaded, setLoaded] = useState(false);
+
   const [faculties, setFaculties] = useState(null);
+  const [loadedFaculties, setLoadedFaculties] = useState(false);
+
+  const [counts, setCounts] = useState(null);
+  const [loadedCounts, setLoadedCounts] = useState(false);
+
   const [fetchError, setFetchError] = useState(false);
 
   useEffect(() => {
-    const url = `http://192.168.0.29:8080/public/faculties?universityId=${params.universityId}`;
+        Promise.all([fetch(`http://192.168.1.254:8080/public/faculties?universityId=${params.universityId}`),
+        fetch(`http://192.168.1.254:8080/public/university/${params.universityId}/sectionAndPostCount`)])
+            .then(([resFaculties, counts]) => Promise.all([resFaculties.json(), counts.json()]))
+            .then(([dataFaculties, dataCounts]) => {
+                let cyclicGraph1 = dataFaculties;
+                let jsogStructure1 = JSOG.encode(cyclicGraph1);
+                cyclicGraph1 = JSOG.decode(jsogStructure1);
+                setFaculties(cyclicGraph1);
+                setLoadedFaculties(true);
 
-    const fetchData = async () => {
-      try {
-        const response = await fetch(url);
-        var cyclicGraph = await response.json();
-        var jsogStructure = JSOG.encode(cyclicGraph);
-        cyclicGraph = JSOG.decode(jsogStructure);
-        setFaculties(cyclicGraph);
-        setLoaded(true);
-      } catch (error) {
-        setFetchError(true);
-      }
-    };
-    fetchData();
-  }, [params.universityId]);
+                let cyclicGraph2 = dataCounts;
+                let jsogStructure2 = JSOG.encode(cyclicGraph2);
+                cyclicGraph2 = JSOG.decode(jsogStructure2);
+                setCounts(cyclicGraph2);
+                setLoadedCounts(true);
+            })
 
-  return loaded && !fetchError && faculties.length !== 0 ? (
+  }, []);
+
+  return loadedFaculties && !fetchError && faculties.length !== 0 ? (
     <>
       <CurrentPageNav>
@@ -55,18 +62,8 @@
       </ProfessorCard>
       <div key={params.universityId}>
-        {faculties.map((faculty) => {
-          let totalPosts = 0;
-          let totalSections = 0;
-          faculty.professors.map((professor) => {
-            totalPosts += professor.relatedOpinions.length;
-            totalSections++;
-          });
-          faculty.studyProgrammes.map((studyProgramme) => {
-            studyProgramme.subjects.map((subject) => {
-              totalPosts += subject.threads.length;
-              totalSections++;
-            });
-          });
-
+        {faculties.map((faculty, idx) => {
+          let totalPosts = parseInt(counts[idx].split(",")[2]);
+          let totalSections = parseInt(counts[idx].split(",")[1]);
+          console.log(counts)
           return (
             <EntityUl key={faculty.facultyId}>
@@ -104,5 +101,5 @@
       </div>
     </>
-  ) : !fetchError && !loaded ? (
+  ) : !fetchError && !loadedFaculties ? (
     <div>
       <LoadingSpinner style={{ marginTop: "140px" }}/>
